//
// Created by robtor on 09.12.22.
//

#ifndef FLOATPUMP_MENU_ENTRY_TYPE_CHECKABLE_H
#define FLOATPUMP_MENU_ENTRY_TYPE_CHECKABLE_H

#include "Menu_Entry_Type_Delegate.h"

namespace floatpump::menu {

    class Menu_Entry_Type_Checkable : public Menu_Entry_Type_Delegate {
    public:
        explicit Menu_Entry_Type_Checkable(bool mState);

        std::string toString() override;

        void u_press() override;

        void u_increase(uint16_t steps) override;

        void u_decrease(uint16_t steps) override;

        bool isEntered() override;

        void linkConfig(bool *link);

    private:
        bool *m_state;
    };

} // menu

#endif //FLOATPUMP_MENU_ENTRY_TYPE_CHECKABLE_H
